use crate::common_usings::*;
use pkmn_lib_interface::PkmnResult;

script!(IncreasedCriticalStage, "increased_critical_stage");

impl Script for IncreasedCriticalStage {
    fn new() -> Self {
        Self {}
    }

    fn get_name(&self) -> &'static str {
        Self::get_const_name()
    }

    fn get_capabilities(&self) -> &[ScriptCapabilities] {
        &[ScriptCapabilities::ChangeCriticalStage]
    }

    fn change_critical_stage(
        &self,
        _move: ExecutingMove,
        _target: Pokemon,
        _hit: u8,
        stage: &mut u8,
    ) -> PkmnResult<()> {
        *stage += 1;
        Ok(())
    }

    fn as_any(&self) -> &dyn Any {
        self
    }
}
