use crate::common_usings::*;

pub struct ForceEffectTriggerScript {}

impl ForceEffectTriggerScript {
    pub const fn get_const_name() -> &'static str {
        "force_effect_trigger"
    }
}

impl Script for ForceEffectTriggerScript {
    fn new() -> Self {
        Self {}
    }

    fn get_name(&self) -> &'static str {
        Self::get_const_name()
    }

    fn get_capabilities(&self) -> &[ScriptCapabilities] {
        &[ScriptCapabilities::ChangeEffectChance]
    }

    fn change_effect_chance(
        &self,
        _mv: ExecutingMove,
        _target: Pokemon,
        _hit: u8,
        chance: &mut f32,
    ) -> PkmnResult<()> {
        // Set to 50_000% chance.
        *chance = 50_000.0;
        Ok(())
    }

    fn as_any(&self) -> &dyn Any {
        self
    }
}
